"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = exports.transformJest = exports.transformSync = void 0;
const core_1 = require("@swc/core");
function transformOption(path, options, jest = false) {
    var _a, _b;
    const opts = options == null ? {} : options;
    opts.esModuleInterop = (_a = opts.esModuleInterop) !== null && _a !== void 0 ? _a : true;
    return {
        filename: path,
        jsc: {
            target: (_b = opts.target) !== null && _b !== void 0 ? _b : 'es2018',
            parser: {
                syntax: 'typescript',
                tsx: typeof opts.jsx !== 'undefined' ? opts.jsx : path.endsWith('.tsx'),
                decorators: Boolean(opts.experimentalDecorators),
                dynamicImport: Boolean(opts.dynamicImport),
            },
            transform: {
                legacyDecorator: Boolean(opts.experimentalDecorators),
                decoratorMetadata: Boolean(opts.emitDecoratorMetadata),
                // @ts-expect-error
                react: options === null || options === void 0 ? void 0 : options.react,
                hidden: {
                    jest,
                },
            },
        },
        minify: false,
        isModule: true,
        module: {
            type: 'commonjs',
            noInterop: !opts.esModuleInterop,
        },
        sourceMaps: typeof opts.sourcemap === 'undefined' ? true : opts.sourcemap,
        swcrc: false,
    };
}
function transformSync(source, path, options) {
    return core_1.transformSync(source, transformOption(path, options));
}
exports.transformSync = transformSync;
function transformJest(source, path, options) {
    return core_1.transformSync(source, transformOption(path, options, true));
}
exports.transformJest = transformJest;
function transform(source, path, options) {
    return core_1.transform(source, transformOption(path, options));
}
exports.transform = transform;
//# sourceMappingURL=index.js.map